<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AirlineBookingDetailsType StructType
 * @subpackage Structs
 */
class AirlineBookingDetailsType extends AbstractStructBase
{
    /**
     * The PNR
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PNR;
    /**
     * The TicketNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TicketNumber;
    /**
     * The InternalCustomerCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InternalCustomerCode;
    /**
     * The ReservationSystem
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ReservationSystem;
    /**
     * The TravelAgencyCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TravelAgencyCode;
    /**
     * The TravelAgencyName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TravelAgencyName;
    /**
     * The PayerTravelling
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $PayerTravelling;
    /**
     * The Passengers
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PassengerType[]
     */
    public $Passengers;
    /**
     * The FlightLegs
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\FlightLegType[]
     */
    public $FlightLegs;
    /**
     * Constructor method for AirlineBookingDetailsType
     * @uses AirlineBookingDetailsType::setPNR()
     * @uses AirlineBookingDetailsType::setTicketNumber()
     * @uses AirlineBookingDetailsType::setInternalCustomerCode()
     * @uses AirlineBookingDetailsType::setReservationSystem()
     * @uses AirlineBookingDetailsType::setTravelAgencyCode()
     * @uses AirlineBookingDetailsType::setTravelAgencyName()
     * @uses AirlineBookingDetailsType::setPayerTravelling()
     * @uses AirlineBookingDetailsType::setPassengers()
     * @uses AirlineBookingDetailsType::setFlightLegs()
     * @param string $pNR
     * @param string $ticketNumber
     * @param string $internalCustomerCode
     * @param string $reservationSystem
     * @param string $travelAgencyCode
     * @param string $travelAgencyName
     * @param bool $payerTravelling
     * @param \StructType\PassengerType[] $passengers
     * @param \StructType\FlightLegType[] $flightLegs
     */
    public function __construct($pNR = null, $ticketNumber = null, $internalCustomerCode = null, $reservationSystem = null, $travelAgencyCode = null, $travelAgencyName = null, $payerTravelling = null, array $passengers = array(), array $flightLegs = array())
    {
        $this
            ->setPNR($pNR)
            ->setTicketNumber($ticketNumber)
            ->setInternalCustomerCode($internalCustomerCode)
            ->setReservationSystem($reservationSystem)
            ->setTravelAgencyCode($travelAgencyCode)
            ->setTravelAgencyName($travelAgencyName)
            ->setPayerTravelling($payerTravelling)
            ->setPassengers($passengers)
            ->setFlightLegs($flightLegs);
    }
    /**
     * Get PNR value
     * @return string
     */
    public function getPNR()
    {
        return $this->PNR;
    }
    /**
     * Set PNR value
     * @param string $pNR
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setPNR($pNR = null)
    {
        // validation for constraint: string
        if (!is_null($pNR) && !is_string($pNR)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pNR, true), gettype($pNR)), __LINE__);
        }
        $this->PNR = $pNR;
        return $this;
    }
    /**
     * Get TicketNumber value
     * @return string|null
     */
    public function getTicketNumber()
    {
        return $this->TicketNumber;
    }
    /**
     * Set TicketNumber value
     * @param string $ticketNumber
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setTicketNumber($ticketNumber = null)
    {
        // validation for constraint: string
        if (!is_null($ticketNumber) && !is_string($ticketNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticketNumber, true), gettype($ticketNumber)), __LINE__);
        }
        $this->TicketNumber = $ticketNumber;
        return $this;
    }
    /**
     * Get InternalCustomerCode value
     * @return string|null
     */
    public function getInternalCustomerCode()
    {
        return $this->InternalCustomerCode;
    }
    /**
     * Set InternalCustomerCode value
     * @param string $internalCustomerCode
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setInternalCustomerCode($internalCustomerCode = null)
    {
        // validation for constraint: string
        if (!is_null($internalCustomerCode) && !is_string($internalCustomerCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($internalCustomerCode, true), gettype($internalCustomerCode)), __LINE__);
        }
        $this->InternalCustomerCode = $internalCustomerCode;
        return $this;
    }
    /**
     * Get ReservationSystem value
     * @return string|null
     */
    public function getReservationSystem()
    {
        return $this->ReservationSystem;
    }
    /**
     * Set ReservationSystem value
     * @param string $reservationSystem
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setReservationSystem($reservationSystem = null)
    {
        // validation for constraint: string
        if (!is_null($reservationSystem) && !is_string($reservationSystem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($reservationSystem, true), gettype($reservationSystem)), __LINE__);
        }
        $this->ReservationSystem = $reservationSystem;
        return $this;
    }
    /**
     * Get TravelAgencyCode value
     * @return string|null
     */
    public function getTravelAgencyCode()
    {
        return $this->TravelAgencyCode;
    }
    /**
     * Set TravelAgencyCode value
     * @param string $travelAgencyCode
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setTravelAgencyCode($travelAgencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($travelAgencyCode) && !is_string($travelAgencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($travelAgencyCode, true), gettype($travelAgencyCode)), __LINE__);
        }
        $this->TravelAgencyCode = $travelAgencyCode;
        return $this;
    }
    /**
     * Get TravelAgencyName value
     * @return string|null
     */
    public function getTravelAgencyName()
    {
        return $this->TravelAgencyName;
    }
    /**
     * Set TravelAgencyName value
     * @param string $travelAgencyName
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setTravelAgencyName($travelAgencyName = null)
    {
        // validation for constraint: string
        if (!is_null($travelAgencyName) && !is_string($travelAgencyName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($travelAgencyName, true), gettype($travelAgencyName)), __LINE__);
        }
        $this->TravelAgencyName = $travelAgencyName;
        return $this;
    }
    /**
     * Get PayerTravelling value
     * @return bool|null
     */
    public function getPayerTravelling()
    {
        return $this->PayerTravelling;
    }
    /**
     * Set PayerTravelling value
     * @param bool $payerTravelling
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setPayerTravelling($payerTravelling = null)
    {
        // validation for constraint: boolean
        if (!is_null($payerTravelling) && !is_bool($payerTravelling)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($payerTravelling, true), gettype($payerTravelling)), __LINE__);
        }
        $this->PayerTravelling = $payerTravelling;
        return $this;
    }
    /**
     * Get Passengers value
     * @return \StructType\PassengerType[]|null
     */
    public function getPassengers()
    {
        return $this->Passengers;
    }
    /**
     * This method is responsible for validating the values passed to the setPassengers method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPassengers method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePassengersForArrayConstraintsFromSetPassengers(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $airlineBookingDetailsTypePassengersItem) {
            // validation for constraint: itemType
            if (!$airlineBookingDetailsTypePassengersItem instanceof \StructType\PassengerType) {
                $invalidValues[] = is_object($airlineBookingDetailsTypePassengersItem) ? get_class($airlineBookingDetailsTypePassengersItem) : sprintf('%s(%s)', gettype($airlineBookingDetailsTypePassengersItem), var_export($airlineBookingDetailsTypePassengersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Passengers property can only contain items of type \StructType\PassengerType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Passengers value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerType[] $passengers
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setPassengers(array $passengers = array())
    {
        // validation for constraint: array
        if ('' !== ($passengersArrayErrorMessage = self::validatePassengersForArrayConstraintsFromSetPassengers($passengers))) {
            throw new \InvalidArgumentException($passengersArrayErrorMessage, __LINE__);
        }
        $this->Passengers = $passengers;
        return $this;
    }
    /**
     * Add item to Passengers value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerType $item
     * @return \StructType\AirlineBookingDetailsType
     */
    public function addToPassengers(\StructType\PassengerType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengerType) {
            throw new \InvalidArgumentException(sprintf('The Passengers property can only contain items of type \StructType\PassengerType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Passengers[] = $item;
        return $this;
    }
    /**
     * Get FlightLegs value
     * @return \StructType\FlightLegType[]|null
     */
    public function getFlightLegs()
    {
        return $this->FlightLegs;
    }
    /**
     * This method is responsible for validating the values passed to the setFlightLegs method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFlightLegs method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFlightLegsForArrayConstraintsFromSetFlightLegs(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $airlineBookingDetailsTypeFlightLegsItem) {
            // validation for constraint: itemType
            if (!$airlineBookingDetailsTypeFlightLegsItem instanceof \StructType\FlightLegType) {
                $invalidValues[] = is_object($airlineBookingDetailsTypeFlightLegsItem) ? get_class($airlineBookingDetailsTypeFlightLegsItem) : sprintf('%s(%s)', gettype($airlineBookingDetailsTypeFlightLegsItem), var_export($airlineBookingDetailsTypeFlightLegsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FlightLegs property can only contain items of type \StructType\FlightLegType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FlightLegs value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightLegType[] $flightLegs
     * @return \StructType\AirlineBookingDetailsType
     */
    public function setFlightLegs(array $flightLegs = array())
    {
        // validation for constraint: array
        if ('' !== ($flightLegsArrayErrorMessage = self::validateFlightLegsForArrayConstraintsFromSetFlightLegs($flightLegs))) {
            throw new \InvalidArgumentException($flightLegsArrayErrorMessage, __LINE__);
        }
        $this->FlightLegs = $flightLegs;
        return $this;
    }
    /**
     * Add item to FlightLegs value
     * @throws \InvalidArgumentException
     * @param \StructType\FlightLegType $item
     * @return \StructType\AirlineBookingDetailsType
     */
    public function addToFlightLegs(\StructType\FlightLegType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\FlightLegType) {
            throw new \InvalidArgumentException(sprintf('The FlightLegs property can only contain items of type \StructType\FlightLegType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FlightLegs[] = $item;
        return $this;
    }
}
