<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BrowserType StructType
 * @subpackage Structs
 */
class BrowserType extends AbstractStructBase
{
    /**
     * The UserAgent
     * @var string
     */
    public $UserAgent;
    /**
     * The Language
     * Meta information extracted from the WSDL
     * - base: xs:token
     * - pattern: ([a-zA-Z]{2}|[iI]-[a-zA-Z]+|[xX]-[a-zA-Z]{1,8})(-[a-zA-Z]{1,8})*
     * @var string
     */
    public $Language;
    /**
     * Constructor method for BrowserType
     * @uses BrowserType::setUserAgent()
     * @uses BrowserType::setLanguage()
     * @param string $userAgent
     * @param string $language
     */
    public function __construct($userAgent = null, $language = null)
    {
        $this
            ->setUserAgent($userAgent)
            ->setLanguage($language);
    }
    /**
     * Get UserAgent value
     * @return string|null
     */
    public function getUserAgent()
    {
        return $this->UserAgent;
    }
    /**
     * Set UserAgent value
     * @param string $userAgent
     * @return \StructType\BrowserType
     */
    public function setUserAgent($userAgent = null)
    {
        // validation for constraint: string
        if (!is_null($userAgent) && !is_string($userAgent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userAgent, true), gettype($userAgent)), __LINE__);
        }
        $this->UserAgent = $userAgent;
        return $this;
    }
    /**
     * Get Language value
     * @return string|null
     */
    public function getLanguage()
    {
        return $this->Language;
    }
    /**
     * Set Language value
     * @param string $language
     * @return \StructType\BrowserType
     */
    public function setLanguage($language = null)
    {
        // validation for constraint: string
        if (!is_null($language) && !is_string($language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($language, true), gettype($language)), __LINE__);
        }
        // validation for constraint: pattern(([a-zA-Z]{2}|[iI]-[a-zA-Z]+|[xX]-[a-zA-Z]{1,8})(-[a-zA-Z]{1,8})*)
        if (!is_null($language) && !preg_match('/([a-zA-Z]{2}|[iI]-[a-zA-Z]+|[xX]-[a-zA-Z]{1,8})(-[a-zA-Z]{1,8})*/', $language)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression ([a-zA-Z]{2}|[iI]-[a-zA-Z]+|[xX]-[a-zA-Z]{1,8})(-[a-zA-Z]{1,8})*', var_export($language, true)), __LINE__);
        }
        $this->Language = $language;
        return $this;
    }
}
