<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PingResponse StructType
 * @subpackage Structs
 */
class PingResponse extends AbstractStructBase
{
    /**
     * The PingFields
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\KeyValueType[]
     */
    public $PingFields;
    /**
     * The UserDefinedFields
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\KeyValueType[]
     */
    public $UserDefinedFields;
    /**
     * Constructor method for PingResponse
     * @uses PingResponse::setPingFields()
     * @uses PingResponse::setUserDefinedFields()
     * @param \StructType\KeyValueType[] $pingFields
     * @param \StructType\KeyValueType[] $userDefinedFields
     */
    public function __construct(array $pingFields = array(), array $userDefinedFields = array())
    {
        $this
            ->setPingFields($pingFields)
            ->setUserDefinedFields($userDefinedFields);
    }
    /**
     * Get PingFields value
     * @return \StructType\KeyValueType[]|null
     */
    public function getPingFields()
    {
        return $this->PingFields;
    }
    /**
     * This method is responsible for validating the values passed to the setPingFields method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPingFields method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePingFieldsForArrayConstraintsFromSetPingFields(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pingResponsePingFieldsItem) {
            // validation for constraint: itemType
            if (!$pingResponsePingFieldsItem instanceof \StructType\KeyValueType) {
                $invalidValues[] = is_object($pingResponsePingFieldsItem) ? get_class($pingResponsePingFieldsItem) : sprintf('%s(%s)', gettype($pingResponsePingFieldsItem), var_export($pingResponsePingFieldsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PingFields property can only contain items of type \StructType\KeyValueType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PingFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType[] $pingFields
     * @return \StructType\PingResponse
     */
    public function setPingFields(array $pingFields = array())
    {
        // validation for constraint: array
        if ('' !== ($pingFieldsArrayErrorMessage = self::validatePingFieldsForArrayConstraintsFromSetPingFields($pingFields))) {
            throw new \InvalidArgumentException($pingFieldsArrayErrorMessage, __LINE__);
        }
        $this->PingFields = $pingFields;
        return $this;
    }
    /**
     * Add item to PingFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType $item
     * @return \StructType\PingResponse
     */
    public function addToPingFields(\StructType\KeyValueType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeyValueType) {
            throw new \InvalidArgumentException(sprintf('The PingFields property can only contain items of type \StructType\KeyValueType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PingFields[] = $item;
        return $this;
    }
    /**
     * Get UserDefinedFields value
     * @return \StructType\KeyValueType[]|null
     */
    public function getUserDefinedFields()
    {
        return $this->UserDefinedFields;
    }
    /**
     * This method is responsible for validating the values passed to the setUserDefinedFields method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUserDefinedFields method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUserDefinedFieldsForArrayConstraintsFromSetUserDefinedFields(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $pingResponseUserDefinedFieldsItem) {
            // validation for constraint: itemType
            if (!$pingResponseUserDefinedFieldsItem instanceof \StructType\KeyValueType) {
                $invalidValues[] = is_object($pingResponseUserDefinedFieldsItem) ? get_class($pingResponseUserDefinedFieldsItem) : sprintf('%s(%s)', gettype($pingResponseUserDefinedFieldsItem), var_export($pingResponseUserDefinedFieldsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UserDefinedFields property can only contain items of type \StructType\KeyValueType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UserDefinedFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType[] $userDefinedFields
     * @return \StructType\PingResponse
     */
    public function setUserDefinedFields(array $userDefinedFields = array())
    {
        // validation for constraint: array
        if ('' !== ($userDefinedFieldsArrayErrorMessage = self::validateUserDefinedFieldsForArrayConstraintsFromSetUserDefinedFields($userDefinedFields))) {
            throw new \InvalidArgumentException($userDefinedFieldsArrayErrorMessage, __LINE__);
        }
        $this->UserDefinedFields = $userDefinedFields;
        return $this;
    }
    /**
     * Add item to UserDefinedFields value
     * @throws \InvalidArgumentException
     * @param \StructType\KeyValueType $item
     * @return \StructType\PingResponse
     */
    public function addToUserDefinedFields(\StructType\KeyValueType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\KeyValueType) {
            throw new \InvalidArgumentException(sprintf('The UserDefinedFields property can only contain items of type \StructType\KeyValueType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UserDefinedFields[] = $item;
        return $this;
    }
}
