<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ThreeDSecureType StructType
 * @subpackage Structs
 */
class ThreeDSecureType extends AbstractStructBase
{
    /**
     * The Enrolled
     * @var string
     */
    public $Enrolled;
    /**
     * The Paresstatus
     * @var string
     */
    public $Paresstatus;
    /**
     * The Eci
     * @var string
     */
    public $Eci;
    /**
     * The Xid
     * @var string
     */
    public $Xid;
    /**
     * The Cavv
     * @var string
     */
    public $Cavv;
    /**
     * Constructor method for ThreeDSecureType
     * @uses ThreeDSecureType::setEnrolled()
     * @uses ThreeDSecureType::setParesstatus()
     * @uses ThreeDSecureType::setEci()
     * @uses ThreeDSecureType::setXid()
     * @uses ThreeDSecureType::setCavv()
     * @param string $enrolled
     * @param string $paresstatus
     * @param string $eci
     * @param string $xid
     * @param string $cavv
     */
    public function __construct($enrolled = null, $paresstatus = null, $eci = null, $xid = null, $cavv = null)
    {
        $this
            ->setEnrolled($enrolled)
            ->setParesstatus($paresstatus)
            ->setEci($eci)
            ->setXid($xid)
            ->setCavv($cavv);
    }
    /**
     * Get Enrolled value
     * @return string|null
     */
    public function getEnrolled()
    {
        return $this->Enrolled;
    }
    /**
     * Set Enrolled value
     * @uses \EnumType\YNU::valueIsValid()
     * @uses \EnumType\YNU::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $enrolled
     * @return \StructType\ThreeDSecureType
     */
    public function setEnrolled($enrolled = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\YNU::valueIsValid($enrolled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\YNU', is_array($enrolled) ? implode(', ', $enrolled) : var_export($enrolled, true), implode(', ', \EnumType\YNU::getValidValues())), __LINE__);
        }
        $this->Enrolled = $enrolled;
        return $this;
    }
    /**
     * Get Paresstatus value
     * @return string|null
     */
    public function getParesstatus()
    {
        return $this->Paresstatus;
    }
    /**
     * Set Paresstatus value
     * @uses \EnumType\YNUA::valueIsValid()
     * @uses \EnumType\YNUA::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $paresstatus
     * @return \StructType\ThreeDSecureType
     */
    public function setParesstatus($paresstatus = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\YNUA::valueIsValid($paresstatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\YNUA', is_array($paresstatus) ? implode(', ', $paresstatus) : var_export($paresstatus, true), implode(', ', \EnumType\YNUA::getValidValues())), __LINE__);
        }
        $this->Paresstatus = $paresstatus;
        return $this;
    }
    /**
     * Get Eci value
     * @return string|null
     */
    public function getEci()
    {
        return $this->Eci;
    }
    /**
     * Set Eci value
     * @param string $eci
     * @return \StructType\ThreeDSecureType
     */
    public function setEci($eci = null)
    {
        // validation for constraint: string
        if (!is_null($eci) && !is_string($eci)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eci, true), gettype($eci)), __LINE__);
        }
        $this->Eci = $eci;
        return $this;
    }
    /**
     * Get Xid value
     * @return string|null
     */
    public function getXid()
    {
        return $this->Xid;
    }
    /**
     * Set Xid value
     * @param string $xid
     * @return \StructType\ThreeDSecureType
     */
    public function setXid($xid = null)
    {
        // validation for constraint: string
        if (!is_null($xid) && !is_string($xid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xid, true), gettype($xid)), __LINE__);
        }
        $this->Xid = $xid;
        return $this;
    }
    /**
     * Get Cavv value
     * @return string|null
     */
    public function getCavv()
    {
        return $this->Cavv;
    }
    /**
     * Set Cavv value
     * @param string $cavv
     * @return \StructType\ThreeDSecureType
     */
    public function setCavv($cavv = null)
    {
        // validation for constraint: string
        if (!is_null($cavv) && !is_string($cavv)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cavv, true), gettype($cavv)), __LINE__);
        }
        $this->Cavv = $cavv;
        return $this;
    }
}
